﻿using XF.Domain.Authentications;
using XF.Domain.Dependency;
using XF.Domain.Entities;

namespace Hotline.Repository.SqlSugar.DataPermissions;

public class DataPermissionManager : IDataPermissionManager, IScopeDependency
{
    public DataPermissionScheme GetQueryFilter<TEntity>(ISessionContext sessionContext) where TEntity : class, IEntity<string>, IDataPermission, new()
    {
        EQueryFilter? queryFilter = GetCurrentQueryFilter(sessionContext.Roles, typeof(TEntity).Name);
        if (queryFilter == null)
        {
            //todo 未配置数据查询权限处理方案
        }

        if (queryFilter == EQueryFilter.CreatorOnly)
            return new DataPermissionScheme(EQueryFilter.CreatorOnly);

        if (queryFilter == EQueryFilter.SelfAndSubDepartment)
        {
            //todo 查询对应部门编码

            return new DataPermissionScheme(EQueryFilter.SelfAndSubDepartment, "");
        }

        throw new NotImplementedException();
    }

    private EQueryFilter? GetCurrentQueryFilter(string[] roles, string entityName)
    {
        throw new NotImplementedException();
    }
}