﻿using Hotline.Repository.SqlSugar.DataPermissions;
using SqlSugar;
using XF.Domain.Entities;

namespace Hotline.Repository.SqlSugar
{
    public static class QueryExtensions
    {
        public static ISugarQueryable<TEntity> DataPermissionFiltering<TEntity>(this ISugarQueryable<TEntity> queryable, IDataPermissionFilterBuilder dataPermissionFilterBuilder)
            where TEntity : class, IEntity<string>, IDataPermission, new()
        {
            return queryable.Where(dataPermissionFilterBuilder.Build<TEntity>());
        }
    }
}
